
; PicBasic Pro Compiler 2.46, (c) 1998, 2005 microEngineering Labs, Inc. All Rights Reserved.  
PM_USED			EQU	1

	INCLUDE	"16F628.INC"


; Define statements.
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00011	DEFINE PULSIN_MAX 3000  '// MAX wait time for pulsin
#define		PULSIN_MAX		 3000  
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00012	DEFINE NO_CLRWDT        '// Saves 17 words code space
#define		NO_CLRWDT		        

RAM_START       		EQU	00020h
RAM_END         		EQU	0014Fh
RAM_BANKS       		EQU	00003h
BANK0_START     		EQU	00020h
BANK0_END       		EQU	0007Fh
BANK1_START     		EQU	000A0h
BANK1_END       		EQU	000EFh
BANK2_START     		EQU	00120h
BANK2_END       		EQU	0014Fh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	0217Fh

; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00012	R0      VAR     WORD BANK0 SYSTEM       ' System Register
R0              		EQU	RAM_START + 000h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00013	R1      VAR     WORD BANK0 SYSTEM       ' System Register
R1              		EQU	RAM_START + 002h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00014	R2      VAR     WORD BANK0 SYSTEM       ' System Register
R2              		EQU	RAM_START + 004h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00015	R3      VAR     WORD BANK0 SYSTEM       ' System Register
R3              		EQU	RAM_START + 006h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00016	R4      VAR     WORD BANK0 SYSTEM       ' System Register
R4              		EQU	RAM_START + 008h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00017	R5      VAR     WORD BANK0 SYSTEM       ' System Register
R5              		EQU	RAM_START + 00Ah
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00018	R6      VAR     WORD BANK0 SYSTEM       ' System Register
R6              		EQU	RAM_START + 00Ch
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00019	R7      VAR     WORD BANK0 SYSTEM       ' System Register
R7              		EQU	RAM_START + 00Eh
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00020	R8      VAR     WORD BANK0 SYSTEM       ' System Register
R8              		EQU	RAM_START + 010h
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00001	''****************************************************************
T1              		EQU	RAM_START + 012h
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00001	''****************************************************************
T2              		EQU	RAM_START + 014h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00026	FLAGS   VAR     BYTE BANK0 SYSTEM       ' Static flags
FLAGS           		EQU	RAM_START + 016h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00025	GOP     VAR     BYTE BANK0 SYSTEM       ' Gen Op Parameter
GOP             		EQU	RAM_START + 017h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00022	RM1     VAR     BYTE BANK0 SYSTEM       ' Pin 1 Mask
RM1             		EQU	RAM_START + 018h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00024	RM2     VAR     BYTE BANK0 SYSTEM       ' Pin 2 Mask
RM2             		EQU	RAM_START + 019h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00021	RR1     VAR     BYTE BANK0 SYSTEM       ' Pin 1 Register
RR1             		EQU	RAM_START + 01Ah
; C:\PROGRA~1\MECANI~1\MCS\PBP246\PBPPIC14.RAM	00023	RR2     VAR     BYTE BANK0 SYSTEM       ' Pin 2 Register
RR2             		EQU	RAM_START + 01Bh
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00034	IR_PULSE VAR BYTE(13) '// 13-bytes. 8 data ; 5 address
_IR_PULSE        		EQU	RAM_START + 01Ch
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00035	PULSE_IN VAR WORD     '// Raw pulsin value
_PULSE_IN        		EQU	RAM_START + 029h
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00037	ABYTE    VAR BYTE     '// Holds 5-bit hardware address
_ABYTE           		EQU	RAM_START + 02Bh
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00038	ABYTE1   VAR BYTE     '// 2nd address byte storage for verification
_ABYTE1          		EQU	RAM_START + 02Ch
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00031	Cycles   VAR BYTE     '// Holds number of 40KHz carrier cycles
_Cycles          		EQU	RAM_START + 02Dh
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00036	DBYTE    VAR BYTE     '// Holds 8-bit data byte
_DBYTE           		EQU	RAM_START + 02Eh
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00039	DBYTE1   VAR BYTE     '// 2nd data byte storage for verification
_DBYTE1          		EQU	RAM_START + 02Fh
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00040	H_Add    VAR BYTE     '// Holds "Hardware" address
_H_Add           		EQU	RAM_START + 030h
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00033	Index    VAR BYTE     '// Index counter
_Index           		EQU	RAM_START + 031h
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00032	Loops    VAR BYTE     '// Loop counter
_Loops           		EQU	RAM_START + 032h
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00041	X        VAR BYTE     '// Bit pointer for loop
_X               		EQU	RAM_START + 033h
; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00020	PORTL   VAR     PORTB
_PORTL           		EQU	 PORTB
; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00021	PORTH   VAR     PORTA
_PORTH           		EQU	 PORTA
; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00022	TRISL   VAR     TRISB
_TRISL           		EQU	 TRISB
; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00023	TRISH   VAR     TRISA
_TRISH           		EQU	 TRISA
#define _LM              	_PORTA_0
#define _TRISA_6         	 TRISA, 006h
#define _PORTA_0         	 PORTA, 000h
#define _PORTA_6         	 PORTA, 006h
#define _OPTION_REG_7    	 OPTION_REG, 007h
#define _PORTA_7         	 PORTA, 007h
#define _DBYTE_0         	_DBYTE, 000h
#define _ABYTE_0         	_ABYTE, 000h
#define _PORTB_0         	 PORTB, 000h

; Constants.
_Header          		EQU	00060h
_Zero            		EQU	00018h
_One             		EQU	00030h
	INCLUDE	"IR-CHIPS.MAC"
	INCLUDE	"PBPPIC14.LIB"


; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00012	BANK0   $0020, $007F
; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00013	BANK1   $00A0, $00EF
; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00014	BANK2   $0120, $014F
; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00015	EEPROM  $2100, $217F
; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00016	LIBRARY "PBPPIC14"

; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00018	        include "PIC14EXT.BAS"

; C:\PROGRA~1\MECANI~1\MCS\PBP246\16F628.BAS	00025	        include "PBPPIC14.RAM"

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00010	@ DEVICE MCLR_OFF, INTRC_OSC, WDT_OFF, LVP_OFF, BOD_OFF, PWRT_ON, PROTECT_OFF

	ASM?
 DEVICE MCLR_OFF, INTRC_OSC, WDT_OFF, LVP_OFF, BOD_OFF, PWRT_ON, PROTECT_OFF

	ENDASM?

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00011	DEFINE PULSIN_MAX 3000  '// MAX wait time for pulsin
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00012	DEFINE NO_CLRWDT        '// Saves 17 words code space

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00020	CMCON = 7           '// Comparators Off
	MOVE?CB	007h, CMCON

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00021	VRCON = 0           '// Vref Off
	MOVE?CB	000h, VRCON

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00022	TRISA.6 = 1         '// Set for input. 1 = Decode ; 0 = Encode
	MOVE?CT	001h, _TRISA_6
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00025	Header  CON 96      '// Header = (96 * 25uS) = 2.4mS burst
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00026	Zero    CON 24      '// Zero = (24 * 25uS) = 0.6mS burst
; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00027	One     CON 48      '// One = (48 * 25uS) = 1.2mS burst

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00044	  PAUSE 10            '// Stabilize on power-up
	PAUSE?C	00Ah

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00045	  IF PORTA.6 = 1 THEN '// Is Decode MODE selected..?
	CMPNE?TCL	_PORTA_6, 001h, L00001

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00046	   TRISA = $FF        '// Yes. PORTA = inputs for 5-bit address & IR input
	MOVE?CB	0FFh, TRISA

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00047	   PORTB = 0          '// All outputs = 0 (off)
	MOVE?CB	000h, PORTB

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00048	   TRISB = 0          '// PORTB all outputs (8-bit data output)
	MOVE?CB	000h, TRISB

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00049	   OPTION_REG.7 = 1   '// PORTB pull-ups off
	MOVE?CT	001h, _OPTION_REG_7

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00050	   GOTO Decode        '// GOTO Decode routine
	GOTO?L	_Decode

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00051	  ENDIF               '// Else encode function selected
	LABEL?L	L00001	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00052	  TRISB = $FF         '// PORTB = 8-bit switch inputs
	MOVE?CB	0FFh, TRISB

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00053	  OPTION_REG.7 = 0    '// PORTB internal pull-ups = on
	MOVE?CT	000h, _OPTION_REG_7

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00055	  PORTA.7 = 0         '// Transmitter IR LED = off  RA.7 ----|>|----/\/\/\---gnd
	MOVE?CT	000h, _PORTA_7

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00057	  TRISA = %01111111   '// PORTA.7 = output LED drive. Rest inputs for address
	MOVE?CB	07Fh, TRISA

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00058	  GOTO Encode         '// Mode = Encode, jump over sub to Encode routine
	GOTO?L	_Encode

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00060	Pulse:                '// Emits # of 40kHz bursts held in variable Cycles

	LABEL?L	_Pulse	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00061	ASM                   ;// with auto delay between bursts

	ASM?
                   ;// with auto delay between bursts
   bsf porta, 7       ;// 1uS, LED=on [need 25uS total
   goto $+1           ;// 3uS (2uS per goto $+1)
   goto $+1           ;// 5uS
   goto $+1           ;// 7uS
   goto $+1           ;// 9uS
   goto $+1           ;// 11uS
   goto $+1           ;// 13uS 
   bcf porta, 7       ;// 14uS, LED=off
   goto $+1           ;// 16uS
   goto $+1           ;// 18uS
   goto $+1           ;// 20uS
   goto $+1           ;// 22uS
   decfsz _Cycles,F   ;// 23uS
   goto _Pulse        ;// 25us


	ENDASM?


; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00077	   PAUSEUS 500        '// 500uS delay between each data bit
	PAUSEUS?C	001F4h

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00078	   RETURN             '// Return to Main
	RETURN?	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00081	Send:    

	LABEL?L	_Send	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00082	   Cycles = Header    '// Load header pulse time
	MOVE?CB	_Header, _Cycles

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00083	   CALL Pulse         '// Send 2.4mS header/synch pulse
	CALL?L	_Pulse

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00087	   FOR Index = 0 TO 7 '// Loop for 8 bits data
	MOVE?CB	000h, _Index
	LABEL?L	L00003	
	CMPGT?BCL	_Index, 007h, L00004

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00088	    IF DBYTE.0[Index] = 0 THEN '// Get polarity of each data bit to send
	AOUT?TBW	_DBYTE_0, _Index, T1
	CMPNE?WCL	T1, 000h, L00005

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00089	      Cycles = Zero   '// Pulse time = 0.6mS for a "0" data bit
	MOVE?CB	_Zero, _Cycles

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00090	    ELSE
	GOTO?L	L00006
	LABEL?L	L00005	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00091	      Cycles = One    '// Pulse time = 1.2mS for a "1" data bit
	MOVE?CB	_One, _Cycles

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00092	    ENDIF
	LABEL?L	L00006	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00093	    CALL Pulse        '// Send Zero or One data bit/burst
	CALL?L	_Pulse

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00094	   NEXT Index         '// Loop until 8 data-bits sent
	NEXT?BCL	_Index, 001h, L00003
	LABEL?L	L00004	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00098	   ABYTE = (PORTA >> 1) & %00011111 '// ABYTE = address from RA.1 to RA.5
	SHIFTR?BCW	PORTA, 001h, T1
	AND?WCB	T1, 01Fh, _ABYTE

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00099	   FOR Index = 0 TO 4 '// Loop for 5-bits to complete address code
	MOVE?CB	000h, _Index
	LABEL?L	L00007	
	CMPGT?BCL	_Index, 004h, L00008

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00100	    IF ABYTE.0[Index] = 0 THEN '// Get polarity of each address bit to send
	AOUT?TBW	_ABYTE_0, _Index, T1
	CMPNE?WCL	T1, 000h, L00009

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00101	      Cycles = Zero   '// Pulse time = 0.6mS for a "0" address bit
	MOVE?CB	_Zero, _Cycles

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00102	    ELSE
	GOTO?L	L00010
	LABEL?L	L00009	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00103	      Cycles = One    '// Pulse time = 1.2mS for a "1" address bit
	MOVE?CB	_One, _Cycles

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00104	    ENDIF
	LABEL?L	L00010	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00105	    CALL Pulse        '// Send bit
	CALL?L	_Pulse

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00106	   NEXT Index         '// Loop until 5-bits sent
	NEXT?BCL	_Index, 001h, L00007
	LABEL?L	L00008	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00107	   PAUSE  25          '// 25mS delay between packets (40kHz bursts)
	PAUSE?C	019h

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00109	Encode:

	LABEL?L	_Encode	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00110	   IF PORTB != $FF THEN '// Loop until key-press
	CMPEQ?BCL	PORTB, 0FFh, L00011

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00111	    DBYTE = PORTB
	MOVE?BB	PORTB, _DBYTE

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00112	   GOTO Send
	GOTO?L	_Send

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00113	   ENDIF
	LABEL?L	L00011	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00114	   GOTO Encode
	GOTO?L	_Encode

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00116	Decode:                             '// Shift right to remove bit RA.0

	LABEL?L	_Decode	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00117	   H_Add = (PORTA >> 1) & %00011111 '// AND with %00011111 to mask upper 3-bits
	SHIFTR?BCW	PORTA, 001h, T1
	AND?WCB	T1, 01Fh, _H_Add

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00119	Decode2:

	LABEL?L	_Decode2	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00120	   PULSIN PORTA.7,0,PULSE_IN        '// Read-in start pulse
	PULSIN?TCW	_PORTA_7, 000h, _PULSE_IN

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00121	   IF (PULSE_IN < 200) OR (PULSE_IN = 0) THEN '// Less than Start pulse, then keep looking
	CMPLT?WCB	_PULSE_IN, 0C8h, T1
	CMPEQ?WCB	_PULSE_IN, 000h, T2
	LOR?BBW	T1, T2, T2
	CMPF?WL	T2, L00013

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00122	    Loops = 0                       '// Reset Loops on idle or key release
	MOVE?CB	000h, _Loops

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00123	    IF LM = 1 THEN Decode           '// If mode = latching, don't change outputs.
	CMPEQ?TCL	_LM, 001h, _Decode

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00124	    PORTB = 0                       '// Mode = momentary. Key = released or idle
	MOVE?CB	000h, PORTB

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00125	    GOTO Decode                     '// so clear outputs & return.
	GOTO?L	_Decode

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00126	   ENDIF
	LABEL?L	L00013	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00128	Verify:                              '// Read, Decode, then verify data

	LABEL?L	_Verify	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00129	   FOR Index = 0 TO 12               '// Setup to read-in 13 pulses
	MOVE?CB	000h, _Index
	LABEL?L	L00015	
	CMPGT?BCL	_Index, 00Ch, L00016

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00130	    PULSIN PORTA.7,0,IR_PULSE[Index] '// Read 13 low-going pulses on RA.7
	PULSIN?TCW	_PORTA_7, 000h, T1
	AIN?BBB	T1, _IR_PULSE, _Index

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00131	   NEXT Index                        '// Loop x times
	NEXT?BCL	_Index, 001h, L00015
	LABEL?L	L00016	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00132	   DBYTE = $FF                       '// Start with all 1's and find each 0
	MOVE?CB	0FFh, _DBYTE

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00133	   FOR Index = 0 TO 7                '// Get 8 "data" bits
	MOVE?CB	000h, _Index
	LABEL?L	L00017	
	CMPGT?BCL	_Index, 007h, L00018

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00134	    IF IR_PULSE[Index] < 100 THEN DBYTE.0[Index]=0 '// Less than 1mS = 0
	AOUT?BBB	_IR_PULSE, _Index, T1
	CMPGE?BCL	T1, 064h, L00019
	AIN?CTB	000h, _DBYTE_0, _Index
	LABEL?L	L00019	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00135	   NEXT Index
	NEXT?BCL	_Index, 001h, L00017
	LABEL?L	L00018	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00136	   ABYTE = $FF           '// Start with all 1's and find each 0 in pattern
	MOVE?CB	0FFh, _ABYTE

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00137	   X=0                   '// Initialize address bit index pointer to bit 0
	MOVE?CB	000h, _X

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00138	   FOR Index = 8 TO 12   '// Get 5 address bits from IR_PULSE bits 8-12
	MOVE?CB	008h, _Index
	LABEL?L	L00021	
	CMPGT?BCL	_Index, 00Ch, L00022

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00139	    IF IR_PULSE[Index] < 100 THEN ABYTE.0[X]=0
	AOUT?BBB	_IR_PULSE, _Index, T1
	CMPGE?BCL	T1, 064h, L00023
	AIN?CTB	000h, _ABYTE_0, _X
	LABEL?L	L00023	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00140	    X = X + 1            '// Increment address bit index pointer
	ADD?BCB	_X, 001h, _X

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00141	   NEXT Index
	NEXT?BCL	_Index, 001h, L00021
	LABEL?L	L00022	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00142	   ABYTE = ABYTE & %00011111 '// Mask out upper 3-bits. Result = 5-bit address.
	AND?BCB	_ABYTE, 01Fh, _ABYTE

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00151	   Loops = Loops + 1   '// Increment loop counter
	ADD?BCB	_Loops, 001h, _Loops

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00152	   IF Loops = 1 THEN   '// Record data & address bytes only on 1st pass
	CMPNE?BCL	_Loops, 001h, L00025

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00153	    DBYTE1 = DBYTE     '// Load 1st data byte into verify register
	MOVE?BB	_DBYTE, _DBYTE1

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00154	    ABYTE1 = ABYTE     '// Load 1st address byte into verify register
	MOVE?BB	_ABYTE, _ABYTE1

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00155	    GOTO Decode2       '// Get 2nd readings for comparison with 1st two
	GOTO?L	_Decode2

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00156	   ENDIF
	LABEL?L	L00025	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00157	   IF Loops = 255 THEN Loops = 3  '// Prevent roll-overs from 255 to 0 & make sure Loops 
	CMPNE?BCL	_Loops, 0FFh, L00027
	MOVE?CB	003h, _Loops
	LABEL?L	L00027	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00161	   IF ABYTE != (H_Add & ABYTE1) THEN Decode2 '// Does address match?
	AND?BBW	_H_Add, _ABYTE1, T1
	CMPNE?BWL	_ABYTE, T1, _Decode2

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00162	   IF LM = 1 THEN Latch           '// Is latch mode selected?
	CMPEQ?TCL	_LM, 001h, _Latch

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00167	Momentary:

	LABEL?L	_Momentary	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00168	   PORTB = ~DBYTE   '// Momentary mode set so invert & place data on PORTB
	NOT?BB	_DBYTE, PORTB

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00169	   GOTO Decode2
	GOTO?L	_Decode2

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00175	Latch:

	LABEL?L	_Latch	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00176	   IF Loops != 2 THEN Decode2         '// Has key been released?
	CMPNE?BCL	_Loops, 002h, _Decode2

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00177	   IF DBYTE != DBYTE1 THEN Decode2    '// Do both data bytes match?
	CMPNE?BBL	_DBYTE, _DBYTE1, _Decode2

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00178	   FOR Index = 0 TO 7                 '// Yes. Now extract data bits
	MOVE?CB	000h, _Index
	LABEL?L	L00029	
	CMPGT?BCL	_Index, 007h, L00030

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00179	    IF DBYTE.0[Index] = 0 THEN
	AOUT?TBW	_DBYTE_0, _Index, T1
	CMPNE?WCL	T1, 000h, L00031

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00180	     PORTB.0[Index] = PORTB.0[Index] ^ 1  '// XOR port bits to toggle port pins
	AOUT?TBW	_PORTB_0, _Index, T1
	XOR?WCW	T1, 001h, T1
	AIN?WTB	T1, _PORTB_0, _Index

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00181	    ENDIF
	LABEL?L	L00031	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00182	   NEXT Index
	NEXT?BCL	_Index, 001h, L00029
	LABEL?L	L00030	

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00183	   GOTO Decode2
	GOTO?L	_Decode2

; F:\DOCKS\CREATI~1\IR-CHIPS.BAS	00185	   END
	END?	

	END
